<?php

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.controlleradmin');

class ZWeatherControllerLocations extends JControllerAdmin
{
	public function __construct($config = array())
	{
		parent::__construct($config);
	}

	function setDefault()
	{
		// Check for request forgeries
		JRequest::checkToken('default') or die(JText::_('JINVALID_TOKEN'));

		// Get items to publish from the request.
		$cid    = JRequest::getVar('cid', array(), '', 'array');
		$task   = $this->getTask();

		if (empty($cid)) {
			JError::raiseWarning(500, JText::_($this->text_prefix.'_NO_ITEM_SELECTED'));
		} else {
			// Get the model.
			$model = $this->getModel();

			// Make sure the item ids are integers
			JArrayHelper::toInteger($cid);

			// Publish the items.
			if (!$model->setDefault($cid)) {
				JError::raiseWarning(500, $model->getError());
			} else {
				$ntext = $this->text_prefix .'_ITEMS_SET_HOME';
				$this->setMessage(JText::plural($ntext, count($cid)));
			}
		}

		$this->setRedirect(JRoute::_('index.php?option='.$this->option.'&view='.$this->view_list, false));
	}

	public function getModel($name = 'Locations', $prefix = 'ZWeatherModel', $config = array('ignore_request' => true))
	{
		$model = parent::getModel($name, $prefix, $config);
		return $model;
	}
}
