<?php

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');
include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweather.php');

class ZWeatherViewLocation extends JViewLegacy
{
	protected $form;
	protected $item;
	protected $state;
	
	protected $canDo;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		// Initialiase variables.
		$this->form		= $this->get('Form');
		$this->item		= $this->get('Item');
		$this->state	= $this->get('State');
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		$this->canDo	= ZWeatherHelper::getActions("com_zweather.manage");
		
		$this->addToolbar();
		parent::display($tpl);
	}

	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', true);
		$user		= JFactory::getUser();
		$userId		= $user->get('id');
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $userId);
		$canDo	= ZWeatherHelper::getActions("com_zweather.manage");
		JToolBarHelper::title(JText::_('COM_ZWEATHER_'.($checkedOut ? 'VIEW_LOCATION' : ($isNew ? 'ADD_LOCATION' : 'EDIT_LOCATION'))), 'article-add.png');

		// Built the actions for new and existing records.

		// For new records, check the create permission.
		if ($isNew) {
			JToolBarHelper::apply('location.apply');
			JToolBarHelper::save('location.save');
			JToolBarHelper::save2new('location.save2new');
			JToolBarHelper::cancel('location.cancel');
		}
		else {
			// Can't save the record if it's checked out.
			if (!$checkedOut) {
				// Since it's an existing record, check the edit permission, or fall back to edit own if the owner.
				if ($canDo->get('core.edit') || ($canDo->get('core.edit.own') && $this->item->created_by == $userId)) {
					JToolBarHelper::apply('location.apply');
					JToolBarHelper::save('location.save');

					// We can save this record, but check the create permission to see if we can return to make a new one.
					if ($canDo->get('core.create')) {
						JToolBarHelper::save2new('location.save2new');
					}
				}
			}

			// If checked out, we can still save
			if ($canDo->get('core.create')) {
				JToolBarHelper::save2copy('location.save2copy');
			}

			JToolBarHelper::cancel('location.cancel', 'JTOOLBAR_CLOSE');
		}

	}
}
