<?php

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweather.php');

/**
 * View class for a list of locations.
 */
class ZWeatherViewLocations extends JView
{
	protected $items;
	protected $pagination;
	protected $state;

	/**
	 * Display the view
	 *
	 * @return	void
	 */
	public function display($tpl = null)
	{
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');
		$this->authors		= $this->get('Authors');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		// We don't need toolbar in the modal window.
		if ($this->getLayout() !== 'modal') {
			$this->addToolbar();
		}

		// load news feed
		$js = '
		function loadURL(url)
		{
		xmlhttp=null;
		// code for Mozilla, etc.
		if (window.XMLHttpRequest)
		  {
		  xmlhttp=new XMLHttpRequest()
		  }
		// code for IE
		else if (window.ActiveXObject)
		  {
		  xmlhttp=new ActiveXObject("Microsoft.XMLHTTP")
		  }
		if (xmlhttp!=null)
		  {
	      xmlhttp.onreadystatechange=state_Change
		  xmlhttp.open("GET",url,true)
		  xmlhttp.send(null)
		  }
		else
		  {
		  	rsselement.innerHTML = "Your browser does not support XMLHttpRequest().";
		  }
		}
	
		function state_Change(){
		    // only if req shows "complete"
		    if (xmlhttp.readyState == 4) {
		        // only if "OK"
		        if (xmlhttp.status == 200) {
		        	rsselement.innerHTML = xmlhttp.responseText;
		        } else {
		        	rsselement.innerHTML =
		      			"There was a problem retrieving the RSS data: " + xmlhttp.statusText;
		        }
		    }
		}
		
		function onLoadPanel(){
			rsselement = document.getElementById("newspage");
			loadURL("index.php?option=com_zweather&task=rssnews");
		}

		window.addEvent("domready", onLoadPanel);		
		';
		$document = JFactory::getDocument();
		$document->addScriptDeclaration($js);
		JHtml::stylesheet("administrator/components/com_zweather/assets/css/zweather.css");
		
		parent::display($tpl);
	}

	protected function addToolbar()
	{
		$canDo	= ZWeatherHelper::getActions("com_zweather.manage");
		$user		= JFactory::getUser();
		JToolBarHelper::title(JText::_('COM_ZWEATHER'), 'generic.png');

		if ($canDo->get('core.create')) {
			JToolBarHelper::addNew('location.add');
		}

		if (($canDo->get('core.edit')) || ($canDo->get('core.edit.own'))) {
			JToolBarHelper::editList('location.edit');
		}

		if ($canDo->get('core.edit.state')) {
			JToolBarHelper::divider();
			JToolBarHelper::publish('locations.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('locations.unpublish', 'JTOOLBAR_UNPUBLISH', true);
			JToolBarHelper::divider();
			JToolBarHelper::checkin('location.checkin');
		}

		if ($canDo->get('core.delete')) {
			JToolBarHelper::deleteList('', 'locations.delete','JTOOLBAR_DELETE');
			JToolBarHelper::divider();
		}
		elseif ($canDo->get('core.edit.state')) {
			JToolBarHelper::trash('locations.trash');
			JToolBarHelper::divider();
		}

		if ($canDo->get('core.admin')) {
			JToolBarHelper::custom('refresh','refresh.png','refresh.png','Refresh Data',true);
			JToolBarHelper::preferences('com_zweather');
			JToolBarHelper::divider();
		}

		//JToolBarHelper::help('JHELP_CONTENT_ARTICLE_MANAGER');
	}

	private function _getTime($tseconds){
		$str = "";
		$aseconds = abs($tseconds);
		$days = floor ( $aseconds / 60 / 60 / 24);
		$hours = floor( $aseconds / 60 / 60 ) - $days * 24;
		$minutes = floor($aseconds / 60) - $hours * 60;
		$seconds = $aseconds - $minutes*60 - $hours * 60 * 60;
		$tstr = "";
		if($days > 0){
			switch($days){
				case 1:
					$tstr = "1 day";
					break;
				default:
					$tstr = sprintf("%s days",$days);
					break;
			}
		}
		elseif($hours > 0){
			switch($hours){
				case 1:
					$tstr = "1 hour";
					break;
				default:
					$tstr = sprintf("%s hours",$hours);
					break;
			}
		}
		elseif($minutes > 0){
			switch($minutes){
				case 1:
					$tstr = "1 minute";
					break;
				default:
					$tstr = sprintf("%s minutes",$minutes);
					break;
			}
		}
		else {
			if($seconds < 30)
				$tstr = "a few seconds";
			else
				$tstr = "less than a minute";
		}
		if($tseconds > 0)
			$str = $tstr . " remaining";
		else
			$str = sprintf("expired %s ago",$tstr);
		return $str;
	}
	
	function showCacheStatus($id, $options) {
		$iconurl= JURI::root() . "/components/com_zweather/assets/images/";
		$iconok = $iconurl . 'iconok.png';
		$iconnew = $iconurl . 'iconnew.png';
		$iconwarn = $iconurl . 'iconwarning.png';

		$cachefile[]='fcast24';
		$cachefile[]='fcast12';
		$cachefile[]='fcast3';
		$cachefile[]='alert';
		$cachefile[]='observe';
		$setting[]='fcastcache';
		$setting[]='fcastcache';
		$setting[]='fcastcache';
		$setting[]='alertcache';
		$setting[]='observecache';
		$imgpath = "components/com_zweather/assets/images/";
		$htmlstatus = '';
		//echo _CACHEFOLDER . "<br/>";
		for($i =0 ; $i < count($cachefile); $i++) {
			$stat = ZWeatherHelper::getXMLCacheStatus($id,$cachefile[$i]);
			$time = $this->_getTime($stat);
			if($stat > 0)
					$htmlstatus .= "<img title='$time' src='" . $imgpath . "tick.png" . "' />";
			elseif($stat < 0)
					$htmlstatus .= "<img title='$time' src='" . $imgpath . "notice.png" . "' />";
			else
					$htmlstatus .= "<img src='" . $imgpath . "disabled.png" . "' />";
			/*
			switch($stat){
				case 1:
					$htmlstatus .= "<img src='" . $imgpath . "tick.png" . "' />";
					break;
				case 0:
				default:
					$htmlstatus .= "<img src='" . $imgpath . "disabled.png" . "' />";
					break;
				case -1:
					$htmlstatus .= "<img src='" . $imgpath . "notice.png" . "' />";
					break;
			}
			*/
			//$htmlstatus .= $cid;
			/*
			$zfile = new ZCacheStorageZFile();
			$title = $zfile->time_to_expire($id,_CACHEGROUP);
			if ($xmldata = $cache->get($cid, _CACHEGROUP)) {
				// cache hit!
				$htmlstatus .= '<span><a href="' . $href . '" target="_blank" title="'.$title.'"><img src="' . $iconok . '" width="16" height="16" border="0" /></a></span>';
			}
			else {
				// cache miss!
				$htmlstatus .= '<span><a href="' . $href . '" target="_blank"><img src="' . $iconwarn . '" width="16" height="16" border="0" /></a></span>';
			}
			*/

		}
		return $htmlstatus;

	}
		
}
