<?php
/**
 * @package		Joomla.Site
 * @subpackage	com_users
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

class ZWeatherController extends JControllerLegacy
{
	/**
	 * Method to display a view.
	 *
	 * @param	boolean			If true, the view output will be cached
	 * @param	array			An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
	 *
	 * @return	JController		This object to support chaining.
	 * @since	1.5
	 */
	public function display($cachable = false, $urlparams = false)
	{
		// Get the document object.
		$document	= JFactory::getDocument();

		$vName	 = JRequest::getCmd('view', 'location');
		$vFormat = $document->getType();
		$lName	 = JRequest::getCmd('layout', 'default');
		$task = JRequest::getCmd('task','');
		if(strtolower($task) == 'cron'){
			$this->_doCron();
			exit;
		}
		if ($view = $this->getView($vName, $vFormat)) {
			// Do any specific processing by view.
			switch ($vName) {
				default:
				case "location":
					//$this->setRedirect(JRoute::_('index.php?option=com_zweather&view=location', false));
					//return;
					$model = $this->getModel($vName);
					
					break;
			}
		}
		$view->setModel($model, true);
		$view->setLayout($lName);

		// Push document object into the view.
		$view->assignRef('document', $document);

		$view->display();
	}
	
	private function _doCron(){
		if($this->_allowCron()){
			$query = "SELECT id FROM #__zweather_locations WHERE published = 1";
			$model = $this->getModel("Location");
			$db = JFactory::getDbo();
			$db->setQuery($query);
			$ids = $db->loadColumn();
			$model->refreshCron($ids);
			echo "XML refresh completed";
		}
	}

	function _allowCron(){
		$user = JFactory::getUser();
		if($user->id > 0)
			return false;
		$gparams = JComponentHelper::getParams('com_zweather');
		$host = $_SERVER["REMOTE_ADDR"];
		$ips = str_replace(" ","",$gparams->get('cronip'));
		$iplist = explode(",",$ips);
		$iplist[] = "127.0.0.1"; // add localhost to allowable cron hosts
		$count = 0;
		foreach($iplist as $ipcheck)
			$count+=preg_match('/^' .str_replace( '\*', '(.*?)', preg_quote($ipcheck)).'$/', $host);
		if(!in_array($host, $iplist) && $count == 0 ){
			echo sprintf(JText::_("Your computer (ip: %s) is not authorized for this function."), $host);
			return false;
		}
		return true;
	}

}
