<?php

/**
* Z Content Weather Component
* @copyright (C) 2005-2013 Dan Cogliano. All rights reserved.
* www.zcontent.net
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// No direct access.
defined('_JEXEC') or die;

include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'models'.DS.'location.php');

class zWeatherVars{

var $zvars;
var $options;
var $id;
var $xmldoc;
var $xmldocf3;
var $xmldocf12;
var $xmldocf24;
var $xmldoca;
var $xmldoco;
var $xmltype;
var $varcache;

function zWeatherVars($id, $user="unknown method"){
	global $database;
	$this->id = $id;
	$this->varcache = array();
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'assets'.DS.'data'.DS.'zwvars.ini';
		$text = '';
	$fconfig = fopen($configfile, 'r');
	if($fconfig) {
		while (!feof($fconfig)) {
			$text .= fread($fconfig, 8192);
		}
		fclose($fconfig);
	}
	$this->parse($text);
	// load global variables
	
	$this->options = array(
	//"debug" => 1,
	"debug" => 0,
	"user" => $user,
	"startsession" => time());
}

function parse($text) {
	$lines = explode( "\n", $text );
	foreach($lines as $line){
		// ignore comments
		if ($line && ($line[0] == ';' || $line[0] == '#')) {
			continue;
		}
		$line = trim( $line );

		if ($line == '') {
			continue;
		}
		$params = explode(",", $line);
		//echo 'reading ' . $params[0] . "<br/>\n";
		$varname = array_shift($params);
		//echo "var name: " . $varname . "<br/>\n";
		$this->zvars[$varname] = $params;
	}
}

function get($var){
	static $vars = array();
	if(array_key_exists($var, $this->varcache)){
		//echo "var cache hit for $var<br/>\n";
		return $this->varcache[$var];
	}
	if(!is_array(@$this->zvars[$var])){
		// var does not exist
		//echo "does not exist " . count($this->zvars[$var]) . "<br/>\n";
		return array("$var is not defined");
	}
	$result = array();
	$xmltype = $this->zvars[$var][0];
	$xmlparse = "";
	$xmldata = "";
	$rulevars = array();
	$rulevars["trim"] = 0;
	switch($xmltype){
		case 'fcast24':
		case 'fcast':
			if(!is_object($this->xmldocf24)){
				$xmldata = ZWeatherModelLocation::getForecast($this->id);
				if(strlen($xmldata) > 0)
					$this->xmldocf24 = $xmlparse = new SimpleXMLElement($xmldata);
			}
			$xmldoc= $this->xmldocf24;
			break;
		case 'fcast12':
			if(!is_object($this->xmldocf12)){
				$xmldata = ZWeatherModelLocation::getForecast12($this->id);
				if(strlen($xmldata) > 0){
					$this->xmldocf12 = $xmlparse = new SimpleXMLElement($xmldata);
					//echo $xmldata; exit;
				}
			}
			$xmldoc= $this->xmldocf12;
			break;
		case 'fcast3':
			if(!is_object($this->xmldocf3)){
				$xmldata = ZWeatherModelLocation::getForecast3($this->id);
				if(strlen($xmldata) > 0)
					$this->xmldocf3 = $xmlparse = new SimpleXMLElement($xmldata);
			}
			$xmldoc= $this->xmldocf3;
			break;
		case 'alert':
			if(!is_object($this->xmldoca)){
				$xmldata = ZWeatherModelLocation::getAlert($this->id);
				if(strlen($xmldata) > 0)
					$this->xmldoca = $xmlparse = new SimpleXMLElement($xmldata);
			}
			$xmldoc= $this->xmldoca;
			break;
		case 'observe':
			if(!is_object($this->xmldoco)){
				$xmldata = ZWeatherModelLocation::getObservation($this->id);
				if(strlen($xmldata) > 0)
					$this->xmldoco = $xmlparse = new SimpleXMLElement($xmldata);
			}
			$xmldoc= $this->xmldoco;
			break;
		default:
			// unsupported xmltype
			return false;
			break;
	}
	// loop through the rules
	$result = array();
	$returndata = array();
	$debug=0;
	$first=true;
	for($i = 2; $i < count($this->zvars[$var]); $i++){
		$rule = explode(":",$this->zvars[$var][$i]);
		switch($rule[0]){
			case "sp": //search by path
				if(count($rule) == 2)
					$result = $xmldoc->xpath($rule[1]);
				//else
					//$result = $xmldoc->xpath($rule[1])[intval($rule[2])];
				break;
			case "sa": // search by attribute
				break;
			case "ha": // has attribute?
				$attrib = explode("|",$rule[1]);
				$not=false;
				if(substr($attrib[0],0,1) == "!"){
					$not=true;
					$attrib[0] = substr($attrib[0],1);
				}
				for($ia = 0; $ia < count($result); $ia++){
					$item = @$result[$ia];
					if($item[$attrib[0]] == $attrib[1]){
						// found it
						$result = $item;
						break;
					}
				}
				
				break;
			case "mc": // move to child node
				$resultdata = explode("|",@$rule[1]);
				if(is_object($result)){
					if(strlen($resultdata[0]) > 0)
						$result = $result->{$resultdata[0]};
					else{
						foreach( $result->children() as $child){
							$result = $child;
							break;
						}
					}
				}
				elseif(is_array($result)){
					if(strlen($resultdata[0]) > 0)
						$result = $result[$resultdata[0]];
					else
						$result = $result[0];
				}
				/*
				if($result){
					if($debug){
						echo "*** mc ***<br/>\n";
						print_r($result);
					}
					$children = array();
					foreach($result[0]->children() as $child){
						$children[] = $child;
						break;
					}
					$result = $children;
					if($debug){
						print_r($result);
						exit;
					}
					
				}
				*/
				//if(@$result[0])
				//	$result = $result[0];
				/*
				print_r($result);exit;
				if(count($result) > 0){
					$item = $result[0];
					$children = $item->childNodes;
					for($ia = count($result) - 1; $ia >= 0; $ia--)
						$result->removeNode($result->item($ia));
					for($ia = 0; $ia < count($children); $ia++)
						$result->appendNode($children[$ia]);
				}
				*/
				break;
			case "st": // search by text
				$text = explode("|",$rule[1]);
				for($ia = count($result) - 1; $ia >= 0; $ia--){
					$resultcheck = $result[$ia];
					$match = 0;
					foreach($resultcheck->children() as $child){
						//echo "** checking $child with " . $text[0] . ": ";
						//print_r($child);
						if($child == $text[0])
							$match++;
					}
					if(!$match)
						unset($result[$ia]);
				}
				$result = array_values($result);
				break;
			case "ra": // return attribute
				$resultdata = explode("|",$rule[1]);
				foreach($result as $node){
					$returndata[] = $node[$resultdata[0]];
				}
				break;
			case "rt": // return text
				$resultdata = @$rule[1];
				if($resultdata){					
					//$item = @$result[$resultdata];
					if(is_object($result))
					for($ia = 0; $ia < count(@$result->{$resultdata});$ia++){
						$returndata[] = $result->{$resultdata}[$ia];
					}
					elseif(is_array($result))
					for($ia = 0; $ia < count(@$result);$ia++)
						$returndata[] = $result[$ia];
				}
				else{
					for($ia = 0; $ia < count($result); $ia++){
						if(strlen($resultdata) > 0){
							$returndata[] = (string)$result->{$resultdata}[$ia];
						}
						else
							$returndata[] = (string)$result[$ia];
					}
				}
				break;
			case "debug":
				switch(@$rule[1]){
					case "0":
						$debug=0;
						break;
					case 1:
					default:
						$debug=1;
						break;
				}
				break;
			case "def":
				$val = 1;
				if(strlen(@$rule[2]) > 0)
					$val = intval($rule[2]);
				$rulevars[$rule[1]] = $val;
				break;
			default: // invalid rule found
				echo "** Invalid rule for $var ( " . $this->zvars[$var][$i] . " )<br/>\n";
				return;
				break;
		}
		if($debug || $this->options["debug"]){
			if($first){
				echo "*** Debug Weather Variable $var start:<br/>\n";
				//print_r($xmlparse);
				//echo $xmldata;
			}
			switch($rule[0]){
			case "debug":
				break;
			case "def":
				echo "** Debug Set Var " . $rule[1] . " = " . $rulevars[$rule[1]] . "<br/>\n";
				break;
			default:
			echo "** Debug Rule " . @$rule[0] . ": " . @$rule[1] . "<br/>\n";
			if(count($returndata) > 0)
			{
				echo count($returndata) . " elements in return data: " . implode(",", $returndata) . "<br/>\n";
			}
			else {
				if(isset($result)){
					 echo count($result) . " nodes in result list:";
					 print_r($result);
					 echo "<br/>\n";
				}
				else
					echo "No result set found.<br/>\n";
			}
			}
		}
		$first = false;
	}
	unset($result);
	$this->varcache[$var] = $returndata;
	return $returndata;

}

}
