<?php
/**
 * @package		Joomla.Site
 * @subpackage	com_users
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

jimport('joomla.application.component.modelitem');
jimport('joomla.event.dispatcher');
jimport( 'joomla.application.component.helper' );
include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweather.php');
include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweathervars.php');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_zweather'.DS.'tables');


class ZWeatherModelLocation extends JModelItem
{
	protected $forecast12;
	protected $forecast24;
	protected $observation;
	protected $alert;
		
        protected function populateState()
        {
                //$app = JFactory::getApplication('site');
                $app = JFactory::getApplication();

                // Load state from the request.
                $pk = JRequest::getInt('id');
                $this->setState('location.id', $pk);

                // Load the parameters.
                $params = $app->getParams();
                $this->setState('params', $params);
                //echo $this->getForecast($params);
        }
 		
	/**
	 * Method to get the weather forecast data.
	 *
	 * The base form data is loaded and then an event is fired
	 * for users plugins to extend the data.
	 *
	 * @return	mixed		Data object on success, false on failure.
	 * @since	1.6
	 */
	public function getForecast($id)
	{
		static $_forecast24 = null;
		$options = JComponentHelper::getParams('com_zweather');
		if ($_forecast24 === null) {
			$helper = new ZWeatherHelper();
			//$id = $this->getState("location.id");
			$location = ZWeatherModelLocation::getTable();
			//$location = JTable::getInstance("locations");
			$location->load($id);
			$helper->id = $id;
			$helper->latitude = $location->latitude;
			$helper->longitude = $location->longitude;
			$helper->observation_loc = $location->observation_loc;
			$helper->cap_zone = $location->cap_zone;
			$_forecast24 = $helper->getForecastXML($options);
			return $_forecast24;
		}
		else
			return $_forecast24;
	}
	
	public function getForecast12($id)
	{
		static $_forecast12 = null;
		$options = JComponentHelper::getParams('com_zweather');
		if ($_forecast12 === null) {
			$helper = new ZWeatherHelper();
			//if($id == null)
			//	$id = $this->getState("location.id");
			//$location = ZWeatherModelLocation::getTable();
			$location = JTable::getInstance("locations");
			$location->load($id);
			$helper->id = $id;
			$helper->latitude = $location->latitude;
			$helper->longitude = $location->longitude;
			$helper->observation_loc = $location->observation_loc;
			$helper->cap_zone = $location->cap_zone;
			$_forecast12 = $helper->getForecast12XML($options);
			//echo $_forecast12; exit;
			return $_forecast12;
		}
		else
			return $_forecast12;
	}
	
	public function getForecast3($id)
	{
		static $_forecast3 = null;
		$options = JComponentHelper::getParams('com_zweather');
		if ($_forecast3 === null) {
			$helper = new ZWeatherHelper();
			//if($id == null)
			//	$id = $this->getState("location.id");
			//$location = ZWeatherModelLocation::getTable();
			$location = JTable::getInstance("locations");
			$location->load($id);
			$helper->id = $id;
			$helper->latitude = $location->latitude;
			$helper->longitude = $location->longitude;
			$helper->observation_loc = $location->observation_loc;
			$helper->cap_zone = $location->cap_zone;
			return $_forecast3 = $helper->getForecast3XML($options);
		}
		else
			return $_forecast3;
	}
	
	public function getObservation($id)
	{
		static $_observation = null;
		$options = JComponentHelper::getParams('com_zweather');
		if ($_observation === null) {
			$helper = new ZWeatherHelper();
			//if($id == null)
			//	$id = $this->getState("location.id");
			//$location = ZWeatherModelLocation::getTable();
			$location = JTable::getInstance("locations");
			$location->load($id);
			$helper->id = $id;
			$helper->latitude = $location->latitude;
			$helper->longitude = $location->longitude;
			$helper->observation_loc = $location->observation_loc;
			$helper->cap_zone = $location->cap_zone;
			return $_observation = $helper->getObservationXML($options);
		}
		else
			return $_observation;
	}

	public function getAlert($id)
	{
		static $_alert = null;
		$options = JComponentHelper::getParams('com_zweather');
		if ($_alert === null) {
			$helper = new ZWeatherHelper();
			//if($id == null)
			//	$id = $this->getState("location.id");
			//$location = ZWeatherModelLocation::getTable();
			$location = JTable::getInstance("locations");
			$location->load($id);
			$helper->id = $id;
			$helper->latitude = $location->latitude;
			$helper->longitude = $location->longitude;
			$helper->observation_loc = $location->observation_loc;
			$helper->cap_zone = $location->cap_zone;
			return $_alert = $helper->getAlertXML($options);
		}
		else
			return $_alert;
	}
	
	public function getTable($type = "Locations", $prefix = 'JTable', $config = array()){
		JModelItem::addTablePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_zweather'.DS.'tables');
		return JTable::getInstance($type, $prefix, $config);
	}


	function refreshCron($cids){
		$helper = new ZWeatherHelper();
		$params = JComponentHelper::getParams('com_zweather');
		$params->set("cronjob",1);
		
		foreach($cids as $cid){
			set_time_limit(30); // avoiding max execution limit
			$loc = JTable::getInstance("locations");
			$loc->load($cid);
			$helper->latitude = $loc->latitude;
			$helper->longitude = $loc->longitude;
			$helper->id = $cid;
			$helper->observation_loc = $loc->observation_loc;
			$helper->cap_zone = $loc->cap_zone;
			$helper->getForecastXML($params);
			$helper->getForecast12XML($params);
			$helper->getForecast3XML($params);
			$helper->getObservationXML($params);
			$helper->getAlertXML($params);
		}
	}
}
