<?php
/*
Copyright 2013 by Dan Cogliano

This file is part of Zap Weather, a weather application for Joomla.

    Zap Weather is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zap Weather is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$app = JFactory::getApplication();
if($app->isSite())
	include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweathervars.php');

jimport( 'joomla.plugin.plugin' );

/**
 * Example Content Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.5
 */
class plgContentZapWeather extends JPlugin
{
	var $_foundzweather = 0;
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param object $params  The object that holds the plugin parameters
	 * @since 1.5
	 */

	function plgContentZapWeather( &$row, $params ) {
		parent::__construct( $row, $params);
		$zwclass = JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweather.php';
		if(file_exists( $zwclass )){
			$this->_foundzweather=1;
			require_once( $zwclass );
		}
		//echo "in Zap Weather plugin<br/>\n";
		//$this->processZVar($row, $params);
	}

	public function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		if($this->_foundzweather)
			$this->processZVar($row, $params);
	}
	
	// like php's parse_str, but with a choice of delimiter
	function zw_parse_str($mystr, &$returnarray, $delim) {
		$targs=explode($delim,$mystr);
		foreach($targs as $targ){
			$ttarg = explode("=",$targ);
			$returnarray[$ttarg[0]] = $ttarg[1];
		}
	}

	function processZVar(&$row, $params){
		static $defaultid = -1;
		$database =& JFactory::getDBO();
		
		// simple performance check to determine whether bot should process further
		if ( strpos( $row->text, 'zweather' ) === false ) {
			return true;
		}
		//echo "in zweather plugin<br/>\n";
		// expression to search for
		$regex1 = '/{(zweather)\s*(.*?)}/i';
		// if plugin text is within an img tag, it may get converted to this
		$regex2 = '/%7b(zweather)%20*(.*?)%7d/i';
	
		// find all instances of plugin and put in $matches
		$matches = array();
		$matches2 = array();
		$matchstr = array();
		$replacestr = array();
		preg_match_all( $regex1, $row->text, $matches, PREG_SET_ORDER );
		preg_match_all( $regex2, $row->text, $matches2, PREG_SET_ORDER );
		$matches = array_merge($matches,$matches2);
		
	
		// Number of zweather vars in content
		$count = count( $matches );
		if($count > 0){
			// determine default location
			$database->setQuery( "select id from #__zweather_locations order by id" );
			if($defaultid < 0)
				$defaultid = $database->loadResult();
			for($i =0 ; $i < $count; $i++){
				$args = array();
				$this->zw_parse_str(strtolower($matches[$i][2]), $args, ",");
				$loc = @$args['loc'];
				$index = @$args['index'];
				$tformat = @$args['tformat'];
				if(strlen($loc) == 0 || $loc == '0')
					$loc = $defaultid;
					$defaultid = $loc;
				if(strlen($index) == 0)
					$index = '0';
				if(strlen(@$args['var']) > 0 ){
					$zv = new zWeatherVars($loc, "Zap Weather content plugin");
					$value = $zv->get(@$args['var']);
					if(strlen($tformat)>0 && strlen($value[$index])> 0){
						$tdate = ZWeatherHelper::convertDate($value[$index]);
						$value[$index] = strftime($tformat,$tdate);
					}
				}
				$matchstr[]=$matches[$i][0];
				$replacestr[]=@$value[$index];
			}
		//echo implode(",",$matchstr) . "|" . implode(",",$replacestr) . "<br/>\n";
		$row->text = str_replace($matchstr,$replacestr,$row->text);
		}
		// special replace mode for documenting the plugin, replacing "{_zapweather with "{zapweather"
		$row->text = str_replace('{_zweather','{zweather',$row->text);
		return true;
	}

}

?>